#
# Copyright (C) 2012 INRA
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

from jflow.workflow import Workflow


class Alignment (Workflow):

    def process(self):
        """ 
        Run the workflow
        """
        # index the reference genome
        bwaindex = self.add_component("BWAIndex", [self.args["reference_genome"]])
        # align reads against indexed genome
        bwa = self.add_component("BWA", [bwaindex.databank, self.args["read_1"], self.args["read_2"]])